--by Valtteri

local angrySun={}

local pNPC = loadSharedAPI("pnpc")
local myCamera = Camera.get()[1]
local myPlayer = Player(1)
local rng = loadSharedAPI("rng")

local sections = {}
local sectionsActive={}
local sectionsDead={}

local height=480

function angrySun.setSections(setSections)
    sections = setSections
end

function angrySun.setHeight(newHeight)
    height = newHeight
end

function angrySun.onInitAPI()
    registerEvent(angrySun, "onEvent", "onEvent")
    registerEvent(angrySun, "onTick", "onTick")
end

function angrySun.onEvent(eventName)
    if eventName=="Angry Sun" then
        angrySunActive=true
        table.insert(sectionsActive, myPlayer.section)
    elseif eventName=="Angry Sun Dead" then
        angrySunDead=true
        table.insert(sectionsDead, myPlayer.section)
    end
end

function angrySun.onTick()
    local angrySunsStatic=NPC.get(285,-1)
    local angrySunsDynamic=NPC.get(36,-1)
    
    for _,number in ipairs(sections) do
        if myPlayer.section==number then
            isInSection=true
            break
        else
            isInSection=false
        end
    end

    for _,value in ipairs(sectionsActive) do
        if myPlayer.section==value then
            isActiveInSection=true
            break
        else
            isActiveInSection=false
        end
    end
    
    for _,val in ipairs(sectionsDead) do
        if myPlayer.section==val then
            isDeadInSection=true
            break
        else
            isDeadInSection=false
        end
    end
    
    if isDeadInSection~=true and isInSection==true then
        if table.getn(angrySunsStatic) <= 0 and table.getn(angrySunsDynamic) <= 0 then
            if isActiveInSection==true then
                NPC.spawn(36,myCamera.x+64,Section(myPlayer.section).boundary.bottom-height,myPlayer.section)
            elseif isActiveInSection~=true then
                NPC.spawn(285,myCamera.x+64,Section(myPlayer.section).boundary.bottom-height,myPlayer.section)
            end
        end
    end

    for _,npc in ipairs(angrySunsStatic) do
        if isInSection==true then
            npc=pNPC.wrap(npc)
            npc.deathEventName="Angry Sun Dead"
            npc.x=myCamera.x+64
            npc.y=Section(myPlayer.section).boundary.bottom-height
            if isActiveInSection==true then
                npc.id=36
            end
        end
    end
    
    for _,npc in ipairs(angrySunsDynamic) do
        npc=pNPC.wrap(npc)
        npc.deathEventName="Angry Sun Dead"
        
        timerSun=npc.data.timerSun or 0
        lap1=npc.data.lap1 or 0
        numberOfLaps1=npc.data.numberOfLaps1 or 0
        
        timerSun2=npc.data.timerSun2 or 0
        
        timerSun3=npc.data.timerSun3 or 0
        lap2=npc.data.lap2 or 0
        numberOfLaps2=npc.data.numberOfLaps2 or 0
        
        timerSun4=npc.data.timerSun4 or 0
        
        npc.data.resetSun=false
        
        cameraCoordsOld=npc.data.cameraCoordsOld or myCamera.x
        if myCamera.x~=cameraCoordsOld then
            npc.x=npc.x+(myCamera.x-cameraCoordsOld)
        end
        cameraCoordsOld=myCamera.x
        npc.data.cameraCoordsOld=cameraCoordsOld
        if numberOfLaps1==0 then
            numberOfLaps1=rng.randomInt(2,5)
            npc.data.numberOfLaps1=numberOfLaps1
        end
        if lap1<numberOfLaps1 then
            if timerSun>=0 and timerSun<6 then
                npc.y=npc.y-5.333
            elseif timerSun>=6 and timerSun<9 then
                npc.x=npc.x+5.333
                npc.y=npc.y-5.333
            elseif timerSun>=9 and timerSun<15 then
                npc.x=npc.x+5.333
            elseif timerSun>=15 and timerSun<18 then
                npc.x=npc.x+5.333
                npc.y=npc.y+5.333
            elseif timerSun>=18 and timerSun<24 then
                npc.y=npc.y+5.333
            elseif timerSun>=24 and timerSun<27 then
                npc.y=npc.y+5.333
                npc.x=npc.x-5.333
            elseif timerSun>=27 and timerSun<33 then
                npc.x=npc.x-5.333
            elseif timerSun>=33 and timerSun<36 then
                npc.x=npc.x-5.333
                npc.y=npc.y-5.333
            end
            
            timerSun=timerSun+1
            if timerSun>=36 then
                timerSun=0
                lap1=lap1+1
                npc.data.lap1=lap1
            end
            npc.data.timerSun=timerSun
            
        elseif lap1>=numberOfLaps1 then
            if timerSun2>=0 and timerSun2<19 then
                npc.x=myCamera.x+64
                npc.y=Section(myPlayer.section).boundary.bottom-height
            elseif timerSun2>=19 and timerSun2<210 then --191
                npc.x=npc.x+3.328
                npc.y = npc.y+((-0.07)*(((timerSun2-19)%191)-95))
            elseif timerSun2>=210 then
                if numberOfLaps2==0 then
                    numberOfLaps2=rng.randomInt(2,5)
                    npc.data.numberOfLaps2=numberOfLaps2
                end
                if lap2<numberOfLaps2 then
                    if timerSun3>=0 and timerSun3<6 then
                        npc.y=npc.y-5.333
                    elseif timerSun3>=6 and timerSun3<9 then
                        npc.x=npc.x-5.333
                        npc.y=npc.y-5.333
                    elseif timerSun3>=9 and timerSun3<15 then
                        npc.x=npc.x-5.333
                    elseif timerSun3>=15 and timerSun3<18 then
                        npc.x=npc.x-5.333
                        npc.y=npc.y+5.333
                    elseif timerSun3>=18 and timerSun3<24 then
                        npc.y=npc.y+5.333
                    elseif timerSun3>=24 and timerSun3<27 then
                        npc.y=npc.y+5.333
                        npc.x=npc.x+5.333
                    elseif timerSun3>=27 and timerSun3<33 then
                        npc.x=npc.x+5.333
                    elseif timerSun3>=33 and timerSun3<36 then
                        npc.x=npc.x+5.333
                        npc.y=npc.y-5.333
                    end
                    timerSun3=timerSun3+1
                    if timerSun3>=36 then
                        timerSun3=0
                        lap2=lap2+1
                        npc.data.lap2=lap2
                    end
                    npc.data.timerSun3=timerSun3
                elseif lap2>=numberOfLaps2 then
                    if timerSun4>=0 and timerSun4<19 then 
                        npc.x=myCamera.x+704
                        npc.y=Section(myPlayer.section).boundary.bottom-height
                    elseif timerSun4>=19 and timerSun4<210 then --191
                        npc.x=npc.x-3.328
                        npc.y = npc.y+((-0.07)*(((timerSun4-19)%191)-95))
                    elseif timerSun4>=210 then
                        timerSun=0
                        timerSun2=0
                        timerSun3=0
                        timerSun4=0
                        lap1=0
                        lap2=0
                        numberOfLaps1=0
                        numberOfLaps2=0
                        npc.data.timerSun=timerSun
                        npc.data.timerSun2=timerSun2
                        npc.data.timerSun3=timerSun3
                        npc.data.timerSun4=timerSun4
                        npc.data.lap1=lap1
                        npc.data.lap2=lap2
                        npc.data.numberOfLaps1=numberOfLaps1
                        npc.data.numberOfLaps2=numberOfLaps2
                        npc.data.resetSun=true
                    end
                    if npc.data.resetSun==false then
                        timerSun4=timerSun4+1
                        npc.data.timerSun4=timerSun4
                    end
                end
            end
            if npc.data.resetSun==false then
                timerSun2=timerSun2+1
                npc.data.timerSun2=timerSun2
            end
        end
    end
end

return angrySun